/* Problem URL: https://codeforces.com/contest/2114/problem/F */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // vi divs(1e6 + 1, 1);
    //
    // nrep(i, 2, 1e6 + 1) {
    //     if (divs[i] != 1) {
    //         continue;
    //     }
    //
    //     divs[i] = i;
    //
    //     for (int j = i * 2; j <= 1e6; j += i) {
    //         divs[j] = i;
    //     }
    // }
    //
    vvi divisors(1e6 + 1);

    nrep(i, 2, 1e6 + 1) {
        divisors[i].push_back(i);

        for (int j = i * 2; j <= 1e6; j += i) {
            divisors[j].push_back(i);
        }
    }

    int t;
    cin >> t;
    while (t--) {
        ll x, y, z;
        cin >> x >> y >> z;

        // auto fact = [&](ll num, vl &primes) {
        //     while (num > 1) {
        //         primes.push_back(divs[num]);
        //         num /= divs[num];
        //     }
        //
        //     if (num != 1) {
        //         primes.push_back(num);
        //     }
        //
        //     reverse(all(primes));
        // };

        ll gcd = __gcd(x, y);
        x /= gcd;
        y /= gcd;

        // vl primesx;
        // vl primesy;

        // fact(x, primesx);
        // fact(y, primesy);

        // if ((!primesx.empty() && primesx.back() > z) || (!primesy.empty() && primesy.back() > z)) {
        //     cout << "-1\n";
        //     continue;
        // }

        bool valid = true;

        auto getans = [&](ll n) {
            int ans = 0;

            while (n > 1) {
                auto itr = upper_bound(all(divisors[n]), z);
                if (itr == divisors[n].begin()) {
                    valid = false;
                    return 0;
                }

                itr--;
                n /= *itr;
                ans++;
            }

            return ans;
        };

        int ans1 = getans(x);
        int ans2 = getans(y);

        if (!valid) {
            cout << "-1\n";
            continue;
        }

        cout << ans1 + ans2 << '\n';
    }
}
